/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;

/**
 * _uNI[e[VуGXP[vgGXP[vNX<BR>
 * \[XR[hWritero͂ۂɁA_uNI[e[VуGXP[vg
 * ̓GXP[vKv܂B
 * ̃NX͂̂悤ȃGXP[vWriterNXłB<BR>
 *
 * @author Tosiki IGA
 */
public class EscapeQuoteWriter
	extends Writer
{
	protected Writer writer=null;

	/**
	 * _uNI[e[VGXP[vWriterNX̃RXgN^
	 *
	 * @param Writer writer A錳Writer
	 */
	public EscapeQuoteWriter(Writer writer)
	{
		this.writer=writer;
	}

	/**
	 * 1Writerɏ݂܂B
	 *
	 * @param int cWrite ޕ
	 * @throws IOException I/OO
	 */
	public void write(int cWrite)
		throws IOException
	{
		if(cWrite=='"'
		|| cWrite=='\\')
		{
			writer.write('\\');
		}
		writer.write(cWrite);
	}

	/**
	 * zWriter֏݂܂B<BR>
	 * ܂̂ ^ꂽ16i_vł
	 *
	 * @param char cbuf[] ݃obt@
	 * @param int off ݃obt@̃ItZbg
	 * @param int len ݒ
	 * @throws IOException I/OO
	 */
	public final void write(char cbuf[], int off, int len)
		throws IOException
	{
		int iTill=off+len;
		for(int index=off;index<iTill;index++)
		{
			write(cbuf[index]);
		}
	}

	/**
	 * WritertbV܂
	 *
	 * @throws IOException I/OO̔
	 */
	public final void flush()
		throws IOException
	{
		if(writer!=null)
		{
			writer.flush();
		}
	}

	/**
	 * WriterN[Y܂
	 *
	 * @throws IOException I/OO̔
	 */
	public final void close()
		throws IOException
	{
		if(writer!=null)
		{
			writer.close();
			writer=null;
		}
	}
}

