/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * GXP[v[eBeBNX <BR>
 * <BR>
 *
 * @author Tosiki IGA
 */
public class EscapeUtil
{
	/**
	 * ^ꂽ̃_uNI[e[VƃGXP[v
	 * GXP[v郁\bh
	 * 
	 * @param String strInput ͕
	 * @return String GXP[v㕶
	 */
	public static final String encodeQuote(String strInput)
	{
		try{
			Reader reader=new StringReader(strInput);
			StringWriter writerString=new StringWriter();
			Writer writer=new EscapeQuoteWriter(writerString);
			for(;;)
			{
				int iRead=reader.read();
				if(iRead<0)break;
				writer.write(iRead);
			}
			reader.close();
			writer.flush();
			writer.close();
			return writerString.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}
}

