/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import junit.framework.TestCase;
import java.io.*;

/**
 * 16ipϊNXQeXgNXłB
 * JUnit𗘗păeXg{邽߂ɑ݂NXłB<BR>
 * ̃NXg̗prɗp邱Ƃ͖ł傤B
 *
 * @author Tosiki IGA
 */
public class HexDumpTest
	extends TestCase
{
	public HexDumpTest(String name)
	{
		super(name);
	}

	public static final void main(String[] args)
	{
		junit.textui.TestRunner.run(HexDumpTest.class);
	}

	public void testHexDumpWriter()
		throws IOException
	{
		{
			StringWriter writerBuf=new StringWriter();
			HexDumpWriter writer=new HexDumpWriter(writerBuf);
			writer.write("");
			writer.flush();
			writer.close();
			assertEquals(writerBuf.toString(),"3042  3044  3046");
		}

		{
			StringWriter writerBuf=new StringWriter();
			HexDumpWriter writer=new HexDumpWriter(writerBuf);
			writer.write("".getBytes("SJIS"));
			writer.flush();
			writer.close();
			assertEquals(writerBuf.toString(),"82 a0 82 a2 82 a4");
		}
	}

	public void testHexDumpUtil()
		throws IOException
	{
		assertEquals("3042  3044  3046",HexDumpUtil.toString(""));
		assertEquals("82 a0 82 a2 82 a4",HexDumpUtil.toString("".getBytes("SJIS")));

		assertEquals("672c  65e5  306f  6674  5929  306a  308a  3002  96a3  306e  5ba2  306f  826f  304f  67ff  98df  3046  5ba2  3060  3002",HexDumpUtil.toString("{͐VȂBׂ̋q͗ǂ`HqB"));

		assertEquals("0041  0042  0043  0044  0045  002d  0058  0059  005a",HexDumpUtil.toString("ABCDE-XYZ"));
	}

	public void testTinySaxWriter()
		throws IOException
	{
		TinySaxWriter writer=new TinySaxWriter(new BufferedWriter(new OutputStreamWriter(new FileOutputStream("./sample/test/TinySaxWriterTest.xml"))));
		writer.startDocument();
		writer.startElement("person_list",null);

		for(int index=0;index<10;index++)
		{
			java.util.ArrayList list=new java.util.ArrayList();
			list.add(new String[]{"id","code"+index});
			writer.startElement("person",list);

			{
				writer.startElement("name",null);

				writer.startElement("family",null);
				writer.characters("");
				writer.endElement("family");

				writer.startElement("given",null);
				writer.characters("O");
				writer.endElement("given");

				writer.endElement("name");

				writer.startElement("email",null);
				writer.characters("mailto:[AhX"+index);
				writer.endElement("email");

				list=new java.util.ArrayList();
				list.add(new String[]{"subdir","dir"+index});
				writer.startElement("directory",list);
				writer.endElement("directory");
			}


			writer.endElement("person");
		}

		writer.endElement("person_list");
		writer.endDocument();
		writer.flush();
		writer.close();
	}
}


