/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;

/**
 * 16i_vsWriterNX<BR>
 * JsĂ sӂɂf[^16i_vȂ܂B
 * ̃NX ̂悤16i_vsNXłB
 * Ȃ _vo͂̂̂ wx ōs܂B
 *
 * @author Tosiki IGA , Eiichirou Takahashi
 */
public class HexDumpWriter
	extends Writer
{
	protected static final boolean IS_DEBUG=false;

	protected Writer writer=null;
	protected int iSeparatorSpace=0;

	/**
	 * 16i_vsNX̃RXgN^
	 *
	 * @param Writer writer A錳Writer
	 */
	public HexDumpWriter(Writer writer)
	{
		this.writer=writer;
	}

	/**
	 * 1Writerɏ݂܂B
	 *
	 * @param int cWrite ޕ
	 * @throws IOException I/OO
	 */
	public void write(int cWrite)
		throws IOException
	{
		fillSeparatorSpace();

		String str4th=Integer.toHexString((int)((cWrite>>12) & 0x0F));
		String str3th=Integer.toHexString((int)(cWrite>>8) & 0x0F);
		String str2th=Integer.toHexString((int)(cWrite>>4) & 0x0F);
		String str1th=Integer.toHexString((int)cWrite & 0x0F);
		writer.write(str4th+str3th+str2th+str1th);

		iSeparatorSpace+=2;

		if(IS_DEBUG)System.out.println("["+str4th+str3th+str2th+str1th+"]");
	}

	/**
	 * Xy[X𖄂߂܂B
	 *
	 * @param int cWrite ޕ
	 * @throws IOException I/OO
	 */
	protected final void fillSeparatorSpace()
		throws IOException
	{
		for(;iSeparatorSpace>0;iSeparatorSpace--)
		{
			writer.write(' ');
		}
	}

	/**
	 * zWriter֏݂܂B<BR>
	 * ܂̂ ^ꂽ16i_vł
	 *
	 * @param char cbuf[] ݃obt@
	 * @param int off ݃obt@̃ItZbg
	 * @param int len ݒ
	 * @throws IOException I/OO
	 */
	public final void write(char cbuf[], int off, int len)
		throws IOException
	{
		int iTill=off+len;
		for(int index=off;index<iTill;index++)
		{
			write(cbuf[index]);
		}
	}

	/**
	 * oCgzWriter֏݂܂B<BR>
	 * ̃\bh WriterƂϓ_ Ȃwʁxł͂܂B
	 *
	 * @param char cbuf[] ݃obt@
	 * @param int off ݃obt@̃ItZbg
	 * @param int len ݒ
	 * @throws IOException I/OO
	 */
	public final void write(byte buf[])
		throws IOException
	{

		for(int index=0;index<buf.length;index++)
		{
			fillSeparatorSpace();

			int iVal=buf[index];
			if(iVal<0)
			{
				iVal+=256;
			}

			writer.write(Integer.toHexString(iVal));

			iSeparatorSpace+=1;
		}
	}

	/**
	 * WritertbV܂
	 *
	 * @throws IOException I/OO̔
	 */
	public final void flush()
		throws IOException
	{
		if(writer!=null)
		{
			writer.flush();
		}
	}

	/**
	 * WriterN[Y܂
	 *
	 * @throws IOException I/OO̔
	 */
	public final void close()
		throws IOException
	{
		if(writer!=null)
		{
			writer.close();
			writer=null;
		}
	}
}

