/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;

/**
 * CfgtoWriterNX<BR>
 * \[XR[h@BIɏo͂ۂɕKvɂȂ CfgtWriterNXłB
 * Rgo@\܂B<BR>
 *
 * @author Tosiki IGA
 */
public class IndentWriter
	extends PrintWriter
{
	protected static final boolean IS_DEBUG=false;

	protected int iIndent=0;

	protected boolean isComment=false;
	protected boolean isPastLineComment=false;

	/**
	 * CfgtoWriterNX̃RXgN^
	 *
	 * @param Writer writer A錳Writer
	 */
	public IndentWriter(Writer writer)
	{
		super(writer);
	}

	/**
	 * Writer֏݂܂B<BR>
	 * ̃\bh WriterƂϓ_ Ȃwʁxł͂܂B
	 * ܂ ̃\bĥ݂CfgΏۂłB
	 *
	 * @param String strbuf ݕ
	 */
	public void println(String strBuf)
	{
		fillIndent(iIndent);

		if(isComment)
		{
			if(isPastLineComment==false)
			{
				isPastLineComment=true;
				super.println("/**");
				fillIndent(iIndent);
			}
			super.print(" * ");
		}

		if(isComment==false)
		{
			if(isPastLineComment==true)
			{
				isPastLineComment=false;
				super.println(" */");
				fillIndent(iIndent);
			}
		}

		super.println(strBuf);
	}

	/**
	 * WriterֈꎞICfgƋɏ݂܂B<BR>
	 * ̃\bh WriterƂϓ_ Ȃwʁxł͂܂B
	 * ܂ ̃\bĥ݂CfgΏۂłB
	 *
	 * @param String strbuf ݕ
	 */
	public void println(int iTempIndent,String strBuf)
	{
		addIndent(iTempIndent);
		println(strBuf);
		addIndent(-iTempIndent);
	}

	protected void fillIndent(int arg)
	{
		for(int index=arg;index>0;index--)
		{
			super.print('\t');
		}
	}

	/**
	 * Cfg𑝌܂<BR>
	 * ̃\bh PrintWriterƂϓ_ Ȃwʁxł͂܂B
	 *
	 * @param int arg Cfg̑
	 */
	public final void addIndent(int arg)
	{
		iIndent+=arg;
	}

	public final void beginComment()
	{
		isComment=true;
	}

	public final void endComment()
	{
		isComment=false;
	}

	public static final void convert(File fileInput,File fileOutput)
		throws IOException
	{
		BufferedReader reader=new BufferedReader(new InputStreamReader(new FileInputStream(fileInput)));
		BufferedWriter writer=new BufferedWriter(new OutputStreamWriter(new FileOutputStream(fileOutput)));
		for(;;)
		{
			String strRead=reader.readLine();
			if(strRead==null)break;

			writer.write("\t\tout.println(\"");
			writer.write(EscapeUtil.encodeQuote(strRead));
			writer.write("\");");

			writer.newLine();
		}
		reader.close();
		writer.flush();
		writer.close();
	}
}

