/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;

/**
 * pJ^JiSpϊsReaderNXłB<BR>
 * ̃NX𗘗p pJ^Ji̕ SpɕϊȂ
 * i߂Ă܂BΏۂƂȂĂ܂B
 * p͓K؂ȑSpւƕϊ܂BȂ pANKȂǂ͏ΏۊOɂȂ܂B
 *
 * @author Tosiki IGA
 */
public class KatakanaZenkakuReader
	extends ZenkakuReader
{
	/**
	 * pJ^JiSpϊĂNX̃RXgN^
	 *
	 * @param Reader reader A錳Reader
	 */
	public KatakanaZenkakuReader(Reader reader)
	{
		super(reader);
	}

	/**
	 * 1Readerǂݍ݂܂B
	 *
	 * @return int ǂݍ񂾕
	 * @throws IOException I/OO
	 */
	public int read()
		throws IOException
	{
		int iRead=reader.read();
		if(iRead<0)
		{
			return iRead;
		}

		int iReturn=ZenkakuTable.checkHankakuKatakana(reader,iRead);
		if(iReturn>=0)
		{
			return iReturn;
		}

		return iRead;
	}

}

