/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;
import java.util.*;
import java.text.SimpleDateFormat;

/**
 * {ꕶ񑀍Ɋւ郆[eBeBNX<BR>
 * JavaJDBChCo͉͂ĂŊJĂ̂Ȃ̂ŁA
 * {(Ƀ_uoCg)̑֌Wȏꍇ܂<BR>
 * ̃NX ̂悤 {ɂ܂镶 {I
 * ɂ܂郁\bhW߂NXłB
 *
 *   @author Tosiki IGA , Yamauchi Toyohiko , Shinichi Hayashi , Eiichirou Takahashi
 */
public class MojiUtil
{
	/**
	 * fobOWo͂sǂtOB
	 */
	protected static final boolean IS_DEBUG=false;

	/**
	 * ^ꂽ̍؂߂郁\bh<BR>
	 * p󔒂ƑSp󔒂؂߂܂
	 * 
	 *   @param String strInput ͕
	 *   @return String ؂ߌ㕶
	 */
	public static final String trimLeft(String strInput)
	{
		try{
			StringReader reader=new StringReader(strInput);
			StringWriter writer=new StringWriter();
			StringBuffer strbufWhiteSpace=new StringBuffer();

			for(boolean isLeftSpaceEnded=false;;)
			{
				int iRead=reader.read();
				if(iRead<0)break;
				if(isLeftSpaceEnded==false)
				{
					if(iRead==' '
					|| iRead=='@')
					{
						continue;
					}
				}

				// Xy[XI
				isLeftSpaceEnded=true;
				writer.write(iRead);
			}

			reader.close();
			writer.flush();
			writer.close();

			return writer.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽw蒷܂ōɎw蕶𖄂߂郁\bh
	 * 2oCg1̕2ƂăJEg܂B
	 * 
	 *   @param String strInput ͕
	 *   @param int iLength 
	 *   @param char cFill ߂镶
	 *   @return String 
	 */
	public static final String padLeft(String strInput,int iLength,char cFill)
	{
		try{
			int iInputLength=strInput.getBytes().length;

			StringWriter writer=new StringWriter();

			boolean isZenkakuHalfAmari=false;
			for(int iCurrentLength=iInputLength;;)
			{
				if(cFill>0xff)
				{
					iCurrentLength+=2;
					if(iCurrentLength>iLength)
					{
						if(iCurrentLength==(iLength+1))
						{
							isZenkakuHalfAmari=true;
						}
						break;
					}
				}
				else
				{
					iCurrentLength+=1;
				}

				if(iCurrentLength<=iLength)
				{
					writer.write(cFill);
				}
				else
				{
					break;
				}
			}

			writer.write(strInput);

			writer.flush();
			writer.close();

			if(isZenkakuHalfAmari==false)
			{
				return writer.toString();
			}
			else
			{
				return " "+writer.toString();
			}
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽ\Ȍtf[^܂B
	 * YYMMDD YYYYMMDDAYY/MM/DD YY.MM.DD 
	 * (N+)  b : ::b
	 *  AHȂǂ͏ł܂B
	 * 
	 *   @param String strInput ͕
	 *   @return Date oꂽt
	 */
	public static final Date toDate(String strInput)
	{
		strInput=ZenkakuUtil.normalizeZenkaku(strInput);

		if(strInput.length()<=6)
		{
			// 6ȉ̏ꍇ 2000NȗĂ̂Ɖ肵܂B
			strInput="20"+strInput;
		}

		try{
			StringReader reader=new StringReader(strInput);
			CharArrayWriter writer=new CharArrayWriter();

			boolean isYearMode=true;

			int iDateFirst=-1;
			int iDateSecond=-1;
			int iDateThird=-1;

			int iHourFirst=-1;
			int iHourSecond=-1;
			int iHourThird=-1;

			for(;;)
			{
				int iRead=reader.read();
				if(iRead<0)break;
				switch(iRead)
				{
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
						writer.write(iRead);
						break;
					case '/':
					case '.':
					case 'N':
					case '':
					case '':
						// tZp[^
						isYearMode=true;
						break;
					case ':':
					case '':
					case '':
					case 'b':
					case ' ': // tƎ̊Ԃɋ󔒂邾낤
						// Zp[^
						isYearMode=false;
						break;
					case 'H':
					case '':
						// XCb`
						// ݏł܂B
						break;
					case 'S':
					case '':
						// aXCb`
						// ݏł܂B
						break;
					case 'T':
					case '':
						// 吳XCb`
						// ݏł܂B
						break;
					case 'M':
					case '':
						// XCb`
						// ݏł܂B
						break;
				}

				if(writer.size()>=4
				|| (iDateFirst!=-1 && writer.size()>=2))
				{
					if(isYearMode)
					{
						if(iDateFirst==-1)
						{
							iDateFirst=toInteger(writer.toString());
						}
						else if(iDateSecond==-1)
						{
							iDateSecond=toInteger(writer.toString());
						}
						else if(iDateThird==-1)
						{
							iDateThird=toInteger(writer.toString());
						}
					}
					else
					{
						if(iHourFirst==-1)
						{
							iHourFirst=toInteger(writer.toString());
						}
						else if(iHourSecond==-1)
						{
							iHourSecond=toInteger(writer.toString());
						}
						else if(iHourThird==-1)
						{
							iHourThird=toInteger(writer.toString());
						}
					}
					writer.reset();
				}
			}

			if(isYearMode)
			{
				if(iDateFirst==-1)
				{
					iDateFirst=toInteger(writer.toString());
				}
				else if(iDateSecond==-1)
				{
					iDateSecond=toInteger(writer.toString());
				}
				else if(iDateThird==-1)
				{
					iDateThird=toInteger(writer.toString());
				}
			}
			else
			{
				if(iHourFirst==-1)
				{
					iHourFirst=toInteger(writer.toString());
				}
				else if(iHourSecond==-1)
				{
					iHourSecond=toInteger(writer.toString());
				}
				else if(iHourThird==-1)
				{
					iHourThird=toInteger(writer.toString());
				}
			}

			// Ƃ肠 {00:00:00ZbgB
			Calendar calendarResult=Calendar.getInstance();
			calendarResult=trimTime(calendarResult);

			if(iDateThird!=-1)
			{
				if(IS_DEBUG)System.out.println(""+iDateFirst+"N"+iDateSecond+""+iDateThird+"");
				calendarResult.set(Calendar.YEAR,iDateFirst);
				calendarResult.set(Calendar.MONTH,iDateSecond-1);
				calendarResult.set(Calendar.DATE,iDateThird);
			}
			else if(iDateSecond!=-1)
			{
				if(IS_DEBUG)System.out.println(""+iDateFirst+""+iDateSecond+"");
				calendarResult.set(Calendar.MONTH,iDateFirst-1);
				calendarResult.set(Calendar.DATE,iDateSecond);
			}

			if(iHourThird!=-1)
			{
				// b
				if(IS_DEBUG)System.out.println(""+iHourFirst+""+iHourSecond+""+iHourThird+"b");
				calendarResult.set(Calendar.HOUR_OF_DAY,iHourFirst);
				calendarResult.set(Calendar.MINUTE,iHourSecond);
				calendarResult.set(Calendar.SECOND,iHourThird);
			}
			else if(iHourSecond!=-1)
			{
				// 
				if(IS_DEBUG)System.out.println(""+iHourFirst+""+iHourSecond+""+0+"b");
				calendarResult.set(Calendar.HOUR_OF_DAY,iHourFirst);
				calendarResult.set(Calendar.MINUTE,iHourSecond);
				calendarResult.set(Calendar.SECOND,0);
			}

			writer.close();

			return calendarResult.getTime();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽCalendar̎؂߂܂B(00:00:00ɃZbg܂)
	 * 
	 *   @param Calendar calArg ͓t
	 *   @return Calendar t݂̂ɂȂCalendar
	 */
	public static final Calendar trimTime(Calendar calendarArg)
	{
		calendarArg.set(Calendar.HOUR_OF_DAY,0);
		calendarArg.set(Calendar.MINUTE,0);
		calendarArg.set(Calendar.SECOND,0);
		calendarArg.set(Calendar.MILLISECOND,0);
		return calendarArg;
	}

	/**
	 * 镶̒A镶ĕʂ̕ɒu郁\bh<BR>
	 * <xmp>
	 * :
	 *       System.out.println(MojiUtil.replace("''","'","''"));
	 *       System.out.println(MojiUtil.replace("","",""));
	 * </xmp>
	 *
	 *   @param String strInput ϊString
	 *   @param String strFind  镶
	 *   @param String strDest  qbgꍇɒu镶
	 *   @return String u̕
	 */
	public static final String replace(String strInput,String strFind,String strDest)
	{
		try{
			Reader reader=new ReplaceReader(new StringReader(strInput),strFind,strDest);
			Writer writer=new StringWriter();

			for(;;)
			{
				int iRead=reader.read();
				if(iRead<0)break;
				writer.write(iRead);
			}

			reader.close();
			writer.flush();
			writer.close();
			return writer.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * DateYYYYMMDD`̓tɕϊ܂B
	 * 
	 *   @param Date dateArg t
	 *   @return String ꂽt
	 */
	public static final String getYYYYMMDD(Date dateArg)
	{
		SimpleDateFormat sdFormat=new SimpleDateFormat("yyyyMMdd");
		return sdFormat.format(dateArg);
	}

	/**
	 * DateYYMMDD`̓tɕϊ܂B
	 * 
	 *   @param Date dateArg t
	 *   @return String ꂽt
	 */
	public static final String getYYMMDD(Date dateArg)
	{
		SimpleDateFormat sdFormat=new SimpleDateFormat("yyMMdd");
		return sdFormat.format(dateArg);
	}

	/**
	 * DateHHMMSS`̓tɕϊ܂B
	 * 
	 *   @param Date dateArg t
	 *   @return String ꂽ
	 */
	public static final String getHHMMSS(Date dateArg)
	{
		SimpleDateFormat sdFormat=new SimpleDateFormat("HHmmss");
		return sdFormat.format(dateArg);
	}



	// --------------------------------------------------------------------
	// ȍ~́AJSourceCodeWizardNXЂȌ`\[XR[h
	// ]p\̂\[XR[hłB
	// ̗R邽߁Ảӏ͂ȂׂɉqeiX悤ɂĂ܂B
	// --------------------------------------------------------------------

	/**
	 * ^ꂽ\Ȍ萔܂B<BR>
	 * ̃\bh͔p̂ݗLłB
	 * P̃eXgĂ݂ƂAInteger.parseInt()͑Sp
	 * Ă܂ (܂ ̂߂ǂłp\) ͗lłB(at JDK1.3.1)
	 * 
	 *   @param String strInput ͕
	 *   @return int oꂽ
	 */
	public static final int toInteger(String strInput)
	{
		if(strInput==null
		|| strInput.length()==0)
		{
			return 0;
		}
		try{
			return Integer.parseInt(strInput);
		}catch(java.lang.NumberFormatException ex){
			return 0;
		}
	}

	/**
	 * ^ꂽw蒷ɂ҂Ɏ܂悤H郁\bh<BR>
	 * 2oCg1̕2ƂăJEg܂B<BR>
	 * yӁz̃\bhɂĂ JSourceCodeWizardNX쐬ЂȌ`\[XR[h
	 * ̈ꕔƂėp܂BƂ͂̂ق ǂ낵肢܂B<BR>
	 * <BR>
	 * ȂA݂̎ł EUCɂĔpJ^Ji2oCgɂȂ錏ɂđΉĂ܂<BR>
	 * 
	 *   @param String strInput ͕
	 *   @param int iLength 
	 *   @param char cFill ߂镶
	 *   @return String 
	 */
	public static final String fitRight(String strInput,int iLength,char cFill)
	{
		try{
			StringReader reader=new StringReader(strInput);
			StringWriter writer=new StringWriter();
			for(int iCurrentLength=0;;)
			{
				int iRead=reader.read();
				if(iRead<0)break;
				if(iRead>0xff)
				{
					iCurrentLength+=2;
				}
				else
				{
					iCurrentLength+=1;
				}
				if(iCurrentLength<=iLength)
				{
					writer.write(iRead);
				}
				else
				{
					break;
				}
			}
			reader.close();
			writer.flush();
			writer.close();
			return padRight(writer.toString(),iLength,cFill);
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽw蒷܂ŉEɎw蕶𖄂߂郁\bh<BR>
	 * 2oCg1̕2ƂăJEg܂B<BR>
	 * yӁz̃\bhɂĂ JSourceCodeWizardNX쐬ЂȌ`\[XR[h
	 * ̈ꕔƂėp܂BƂ͂̂ق ǂ낵肢܂B<BR>
	 * 
	 *   @param String strInput ͕
	 *   @param int iLength 
	 *   @param char cFill ߂镶B
	 *   @return String 
	 */
	public static final String padRight(String strInput,int iLength,char cFill)
	{
		try{
			int iInputLength=strInput.getBytes().length;

			StringWriter writer=new StringWriter();
			writer.write(strInput);

			for(int iCurrentLength=iInputLength;;)
			{
				if(cFill>0xff)
				{
					iCurrentLength+=2;
					if(iCurrentLength>iLength)
					{
						if(iCurrentLength==(iLength+1))
						{
							writer.write(' ');
						}
						break;
					}
				}
				else
				{
					iCurrentLength+=1;
				}

				if(iCurrentLength<=iLength)
				{
					writer.write(cFill);
				}
				else
				{
					break;
				}
			}

			writer.flush();
			writer.close();

			return writer.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽ̉E؂߂郁\bh
	 * p󔒂ƑSp󔒂؂߂܂
	 * yӁz̃\bhɂĂ JSourceCodeWizardNX쐬ЂȌ`\[XR[h
	 * ̈ꕔƂėp܂BƂ͂̂ق ǂ낵肢܂B<BR>
	 * 
	 *   @param String strInput ͕
	 *   @return String ؂ߌ㕶
	 */
	public static final String trimRight(String strInput)
	{
		try{
			StringReader reader=new StringReader(strInput);
			StringWriter writer=new StringWriter();
			StringBuffer strbufWhiteSpace=new StringBuffer();

			for(;;)
			{
				int iRead=reader.read();
				if(iRead<0)break;
				if(iRead==' '
				|| iRead=='@')
				{
					strbufWhiteSpace.append((char)iRead);
				}
				else
				{
					writer.write(strbufWhiteSpace.toString());
					strbufWhiteSpace=new StringBuffer();
					writer.write(iRead);
				}
			}

			reader.close();
			writer.flush();
			writer.close();

			return writer.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽ̈ꕔ擾郁\bh
	 * 2oCg1̕2ƂăJEg܂B
	 * UnicodeIȓ͍s܂B
	 * rŕfꍇ ̕͏Ȃ p󔒂𖄂߂܂B<BR>
	 * yӁz̃\bhɂĂ JSourceCodeWizardNX쐬ЂȌ`\[XR[h
	 * ̈ꕔƂėp܂BƂ͂̂ق ǂ낵肢܂B<BR>
	 * 
	 *   @param String strInput ͕
	 *   @param int iStart Jnʒu (0IW)
	 *   @param int iLength 擾
	 *   @return String 
	 */
	public static final String subString(String strInput,int iStart,int iLength)
	{
		if(strInput==null)return null;
		if(iLength<=0)return "";
		try{
			StringReader reader=new StringReader(strInput);
			StringWriter writer=new StringWriter();
			int iTotalLength=0;
			// X^[gn_܂ő
			for(int iCurrentLength=0;iCurrentLength<iStart;)
			{
				int iRead=reader.read();
				if(iRead<0)
				{
					// X^[gn_ɓ͂OɏI
					return "";
				}
				if(iRead>0xff)
				{
					iCurrentLength+=2;
					if(iCurrentLength>=iStart)
					{
						if(iCurrentLength>iStart)
						{
							writer.write(' ');
							iTotalLength++;
						}
						break;
					}
				}
				else
				{
					iCurrentLength+=1;
				}
			}
			// w蒷ǂ݂Ƃ
			for(;iTotalLength<iLength;)
			{
				int iRead=reader.read();
				if(iRead<0)break;
				if(iRead>0xff)
				{
					iTotalLength+=2;
					if(iTotalLength>iLength)
					{
						writer.write(' ');
						break;
					}
				}
				else
				{
					iTotalLength+=1;
				}

				writer.write(iRead);
			}
			writer.flush();
			writer.close();
			return writer.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	// --------------------------------------------------------------------
	// ܂ňȑÓAJSourceCodeWizardNXЂȌ`\[XR[h
	// ]p\̂\[XR[hłB
	// ̗R邽߁Ảӏ͂ȂׂɉqeiX悤ɂĂ܂B
	// --------------------------------------------------------------------
}

