/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;

/**
 * pJ^JiSpϊsReaderNXłB<BR>
 * ̃NX𗘗p pJ^Ji̕ SpɕϊȂ
 * i߂Ă܂BΏۂƂȂĂ܂B
 * p͓K؂ȑSpւƕϊ܂BȂ pANKȂǂ͏ΏۊOɂȂ܂B
 *
 * @author Tosiki IGA
 */
public class ReplaceReader
	extends Reader
{
	protected Reader reader=null;
	protected String strFind=null;
	protected String strDest=null;
	protected int iSearchWordLength=-1;
	protected boolean isEndOfStream=false;

	/**
	 * ǂݍ݃obt@
	 */
	protected char[] aryBufOfReader=null;
	protected int iAryBufOfReaderPoint=0;
	protected int iAryBufOfReaderLength=0;

	/**
	 * 񂪈v܂ŕۗĂ[NWriter
	 */
	protected CharArrayWriter writerWork=new CharArrayWriter();

	/**
	 * uReaderNX̃RXgN^
	 *
	 *   @param Reader reader   A錳Reader
	 *   @param String strFind  镶
	 *   @param String strDest  qbgꍇɒu镶
	 */
	public ReplaceReader(Reader reader,String strFind,String strDest)
	{
		this.reader=reader;
		this.strFind=strFind;
		this.strDest=strDest;
		iSearchWordLength=strFind.length();
	}

	/**
	 * 1Readerǂݍ݂܂B
	 *
	 * @return int ǂݍ񂾕
	 * @throws IOException I/OO
	 */
	public int read()
		throws IOException
	{
		if(iAryBufOfReaderPoint<iAryBufOfReaderLength)
		{
			return aryBufOfReader[iAryBufOfReaderPoint++];
		}

		if(isEndOfStream)
		{
			return -1;
		}

		// ۗ̏
		writerWork.reset();

		for(int iSearchPoint=0;;iSearchPoint++)
		{
			int iRead=reader.read();
			if(iRead<0)
			{
				isEndOfStream=true;
				break;
			}

			// ۗɒǉ
			writerWork.write(iRead);

			if(iRead!=strFind.charAt(iSearchPoint))
			{
				break;
			}

			// ͕ƃqbg
			if((iSearchPoint+1)==iSearchWordLength)
			{
				// uSqbg
				// ۗ̓e͔jāAu㕶ɒu܂B
				writeBufToBuffer(strDest.toCharArray());
				return read();
			}
		}

		// u̓qbgȂ̂ŁAۗCOMMITB
		writeBufToBuffer(writerWork.toCharArray());
		return read();
	}

	protected void writeBufToBuffer(char[] arg)
		throws IOException
	{
		aryBufOfReader=arg;
		iAryBufOfReaderPoint=0;
		iAryBufOfReaderLength=aryBufOfReader.length;
	}

	/**
	 * zReaderǂݍ݂܂B<BR>
	 * 2001.08.14 SoOĂ̂ŏC܂BJUnitpR[hLڂ܂B<BR>
	 *
	 * @param char cbuf[] ǂݍݐobt@
	 * @param int off ǂݍݐobt@̃ItZbg
	 * @param int len ǂݍ݉\ȍő咷
	 * @return int ǂݍ񂾕̒
	 * @throws IOException I/OO
	 */
	public final int read(char cbuf[], int off, int len)
		throws IOException
	{
		if(isEndOfStream)
		{
			return -1;
		}

		int iNumberOfCharacters=0;
		int iTill=off+len;
		for(int index=off;index<iTill;index++)
		{
			int iRead=read();
			if(iRead<0)
			{
				isEndOfStream=true;
				break;
			}
			cbuf[index]=(char)iRead;
			iNumberOfCharacters++;
		}
		return iNumberOfCharacters;
	}

	/**
	 * ReaderN[Y܂
	 *
	 * @throws IOException I/OO̔
	 */
	public final void close()
		throws IOException
	{
		if(reader!=null)
		{
			reader.close();
			reader=null;
		}
	}
}


