/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;

/**
 * SpϊsReaderNXłB<BR>
 * 
 * ̃NX𗘗p p̕ \ȌSpɕϊȂ
 * i߂Ă܂BΏۂƂȂĂ܂B
 * łSpɕϊĂ܂Ȃǂɕ֗ȂƂł傤B
 *
 * @author Tosiki IGA
 */
public class ZenkakuReader
	extends Reader
{
	protected static final boolean IS_DEBUG=false;

	protected Reader reader=null;
	protected boolean isEndOfStream=false;

	/**
	 * SpϊNX̃RXgN^
	 *
	 * @param Reader reader A錳Reader
	 */
	public ZenkakuReader(Reader reader)
	{
		this.reader=reader;
	}

	/**
	 * 1Readerǂݍ݂܂B
	 *
	 * @return int ǂݍ񂾕
	 * @throws IOException I/OO
	 */
	public int read()
		throws IOException
	{
		int iRead=reader.read();
		if(iRead<0)
		{
			isEndOfStream=true;
			return iRead;
		}

		int iReturn=ZenkakuTable.checkHankakuKatakana(reader,iRead);
		if(iReturn>=0)
		{
			return iReturn;
		}

		iReturn=ZenkakuTable.checkHankakuAscii(reader,iRead);
		if(iReturn>=0)
		{
			return iReturn;
		}

		return iRead;
	}

	/**
	 * zReaderǂݍ݂܂B<BR>
	 * 2001.08.14 SoOĂ̂ŏC܂BJUnitpR[hLڂ܂B<BR>
	 *
	 * @param char cbuf[] ǂݍݐobt@
	 * @param int off ǂݍݐobt@̃ItZbg
	 * @param int len ǂݍ݉\ȍő咷
	 * @return int ǂݍ񂾕̒
	 * @throws IOException I/OO
	 */
	public final int read(char cbuf[], int off, int len)
		throws IOException
	{
		if(isEndOfStream)
		{
			return -1;
		}

		int iNumberOfCharacters=0;
		int iTill=off+len;
		for(int index=off;index<iTill;index++)
		{
			int iRead=read();
			if(iRead<0)
			{
				isEndOfStream=true;
				break;
			}
			cbuf[index]=(char)iRead;
			iNumberOfCharacters++;
		}
		return iNumberOfCharacters;
	}

	/**
	 * ReaderN[Y܂
	 *
	 * @throws IOException I/OO̔
	 */
	public final void close()
		throws IOException
	{
		if(reader!=null)
		{
			reader.close();
			reader=null;
		}
	}
}

