/**
 * IgaLib -> String
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.string;

import java.io.*;

/**
 * SpɊւ郆[eBeBNX <BR>
 * 
 * JavaJDBChCo͉͂ĂŊJĂ̂Ȃ̂ŁA
 * {(Ƀ_uoCg)̑֌Wȏꍇ܂<BR>
 * ̃NX ̂悤 {AɑSpɂ܂镶
 * ɂ܂郁\bhW߂NXłB
 *
 * @author Tosiki IGA
 */
public class ZenkakuUtil
{
	/**
	 * ^ꂽSp񉻂܂B
	 *
	 * @param String strSource ͕
	 * @return String Spꂽo͕
	 */
	public static final String toZenkaku(String strSource)
	{
		try{
			ZenkakuReader reader=new ZenkakuReader(new StringReader(strSource));
			StringWriter writer=new StringWriter();
			for(;;)
			{
				int iRead=reader.read();
				if(iRead<0)
				{
					break;
				}
				writer.write(iRead);
			}
			reader.close();
			writer.flush();
			writer.close();

			return writer.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽ̂pJ^JiSp񉻂܂B
	 *
	 * @param String strSource ͕
	 * @return String Spꂽo͕
	 */
	public static final String toKatakanaZenkaku(String strSource)
	{
		try{
			KatakanaZenkakuReader reader=new KatakanaZenkakuReader(new StringReader(strSource));
			StringWriter writer=new StringWriter();
			for(;;)
			{
				int iRead=reader.read();
				if(iRead<0)
				{
					break;
				}
				writer.write(iRead);
			}
			reader.close();
			writer.flush();
			writer.close();

			return writer.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽ̂pJ^JiSp񉻂ASpASCII𔼊p񉻂܂B
	 *
	 * @param String strSource ͕
	 * @return String Spꂽo͕
	 */
	public static final String normalizeZenkaku(String strSource)
	{
		if(strSource==null)return null;
		try{
			NormalizeZenkakuReader reader=new NormalizeZenkakuReader(new StringReader(strSource));
			StringWriter writer=new StringWriter();
			for(;;)
			{
				int iRead=reader.read();
				if(iRead<0)
				{
					break;
				}
				writer.write(iRead);
			}
			reader.close();
			writer.flush();
			writer.close();

			return writer.toString();
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
			return null;
		}
	}

	/**
	 * ^ꂽ\Ȍ萔܂B<BR>
	 * ̃\bh͔pƑSpLłB
	 * 
	 *   @param String strInput ͕
	 *   @return int oꂽ
	 */
	public static final int toInteger(String strInput)
	{
		return MojiUtil.toInteger(normalizeZenkaku(strInput));
	}
}

