/**
 * IgaLib -> wizard
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.wizard;

import jp.ne.nifty.iga.tosiki.wizard.wiz.*;
import java.io.*;
import java.util.*;

/**
 * JSourceCodeWizard ̃Gg|CgłB
 * ̃NXXML`t@C(JSourceCodeWizard*.xml)̏Java\[XR[h܂B<BR>
 * Ⴆ΃NX̃tB[hуANZX\bh̐s܂B<BR>
 * <BR>
 * [Generaton Gapp^[] ꂽNXꎩgɂ ɗ͕ύX͉ȂłB
 * ύXƂ NXhĔhNXɕύXĂB
 * (_܂ɂ̎|̃cbR~𒸂܂)<BR>
 * <BR>
 * XML`t@C̒҂ ꂽJava\[XR[h̒҂ɂȂ܂B<BR>
 * <BR>
 * <H3>@</H3>
 * <OL>
 *   <LI>JSourceCodeWizard*.xmlt@C NX̎dlLqĉB
 *   <LI>JSourceCodeWizardsĉB
 *   <LI>ꂽNX B
 * </OL>
 * <P><STRONG>./sample/JSourceCodeWizardMember.xml</STRONG> ̓t@C <STRONG>./sample/DataMember.java</STRONG> sʐꂽJava\[XR[hłB</P>
 * <H3>DB֘A̓mF ({I`FbN̂ݎ{)</H3>
 * <UL>
 *   <LI>Oracle 8.1.7.1
 *   <LI>MS SQLServer 2000
 *   <LI>MS Access JET (MDAC 2.5)
 * </UL>
 * <BR>
 *
 * @author Tosiki IGA
 */
public class JSourceCodeWizard
	extends JSourceCodeWizardAbstract
{
	public static final String VERSION="0.1.6";

	private static final boolean IS_DEBUG=false;

	/**
	 * JgfBNgȉ JSourceCodeWizard*.xmlt@CSď܂B<BR>
	 * ̃NX̃Gg|Cg<BR>
	 *
	 * @param String[] args Ă܂B
	 */
	public static final void main(String[] args)
	{
		prompt();

		try{
			listDirectory(".");
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
		}
	}

	/**
	 * prompt product informations.
	 */
	public static final void prompt()
	{
		System.out.println("JSourceCodeWizard "+VERSION);
		System.out.println("Copyright (C) 2001 Tosiki IGA , IgaLib project member");
		System.out.println("This library is free software, and you are welcome to redistribute it under certain conditions.");
		System.out.println("   WWW   : http://sourceforge.net/projects/jscwiz/");
	}

	private static void listDirectory(String strDirectory)
		throws IOException
	{
		//if(IS_DEBUG)System.out.println("  processing directory:"+strDirectory);

		File fileCheckDirectory=new File(strDirectory);
		File[] fileList=fileCheckDirectory.listFiles();
		if(fileList==null)
		{
			return;
		}

		for(int index=0;index<fileList.length;index++)
		{
			File fileCheckFile=fileList[index];
			if(fileCheckFile.isDirectory()==true)
			{
				String strNextDirectory=strDirectory+"/";
				if(strNextDirectory.equals("./"))
				{
					strNextDirectory="";
				}
				strNextDirectory+=fileCheckFile.getName();
				listDirectory(strNextDirectory);
			}
			else
			{
				if(fileCheckFile.getName().startsWith("JSourceCodeWizard")
				&& fileCheckFile.getName().endsWith(".xml"))
				{
					JSourceCodeWizard accessGenerator=new JSourceCodeWizard();
					System.out.println("  processing:"+strDirectory+"/"+fileCheckFile.getName());
					accessGenerator.setCurrentDirectory(strDirectory+"/");
					accessGenerator.parseXml(new File(strDirectory+"/"+fileCheckFile.getName()));
					JSourceCodeWizardProcessor.write(accessGenerator,accessGenerator.getChannel(),accessGenerator.getField(),strDirectory+"/");
				}
			}
		}
	}

	/**
	 * (I) DBXL[}`XMLt@Co܂B
	 *
	 * @param String strXmlDefFile ݂`t@C
	 */
	public static void writeDefFile(String strXmlDefFile)
		throws IOException
	{
		JSourceCodeWizard wrk_wizard=new JSourceCodeWizard();

		JSourceCodeWizardChannel wrk_channel=new JSourceCodeWizardChannel();
		wrk_channel.setPrefix("Data");
		wrk_channel.setName("Sample");
		wrk_channel.setTitle("Tv`");
		wrk_channel.setDescription("Tvp̃EBU[h`XMLt@Cł");
		wrk_channel.getFunction().setUseSql(true);
		wrk_channel.getIndex().add("MojiKoumoku1,MojiKoumoku2");
		wrk_wizard.setChannel(wrk_channel);

		{
			JSourceCodeWizardField dataItem=new JSourceCodeWizardField();
			dataItem.setName("MojiKoumoku1");
			dataItem.setTitle("11");
			dataItem.setType("char");
			dataItem.setLength(1);
			wrk_wizard.getField().add(dataItem);

			dataItem=new JSourceCodeWizardField();
			dataItem.setName("MojiKoumoku2");
			dataItem.setTitle("2");
			dataItem.setType("String");
			dataItem.setLength(20);
			wrk_wizard.getField().add(dataItem);

			dataItem=new JSourceCodeWizardField();
			dataItem.setName("MojiKoumokuKotekote");
			dataItem.setTitle("ڂĂĎw");
			dataItem.setType("String");
			dataItem.setDefault("\"w\"");
			dataItem.setLength(20);
			dataItem.setPrimary(true);
			dataItem.setNotNull(true);
			wrk_wizard.getField().add(dataItem);
		}

		wrk_wizard.serializeXml(new File(strXmlDefFile));
	}

	/**
	 * ^ꂽNodep[XătB[hɑۂ̌㏈
	 * 
	 *   @param Node nodeLook ̓m[h
	 */
	public void parse(org.w3c.dom.Node nodeLook)
	{
		super.parse(nodeLook);

		JSourceCodeWizardFunction function=getChannel().getFunction();
		if(function.isUseServlet())
		{
			// Servlet  Swing Ƃ͓ݒł܂B
			function.setUseSwing(false);
		}

		for(int index=0;index<getField().size();index++)
		{
			JSourceCodeWizardField field=(JSourceCodeWizardField)getField().get(index);
			field.setChannel(getChannel());
			//System.out.println(field.getDisplayString()+""+getChannel().getDisplayString()+"Zbg");
			field.processInitialize(this);
		}
	}

	private ResourceBundle bundle;

	public void initResourceBundle(String strLocale)
	{
		try{
			bundle=ResourceBundle.getBundle("jp.ne.nifty.iga.tosiki.wizard.jscwiz",new java.util.Locale(strLocale,"",""));
		}catch(MissingResourceException ex){
			throw new Error("Error: missing resource bundle: initResourceBundle: "+ex.getClassName());
		}
	}

	public final String getString(String key)
	{
		return getString(key, null);
	}

	public final String getString(String key,Object[] args)
	{
		if(bundle==null)
		{
			//initResourceBundle("en");
			initResourceBundle(getChannel().getLanguage());
		}

		try{
			String msg=bundle.getString(key);
			if(args==null)
			{
				return msg;
			}
			java.text.MessageFormat format=new java.text.MessageFormat(msg);
			return format.format(args);
		}catch(MissingResourceException ex){
			throw new Error("Error: missing resource for ("+key+"): "+ex.getClassName());
		}
	}
}

