/**
 * IgaLib -> wizard
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.wizard;

import jp.ne.nifty.iga.tosiki.wizard.wiz.*;
import jp.ne.nifty.iga.tosiki.string.IndentWriter;
import java.io.*;
import java.util.*;

/**
 * JSourceCodeWizard ̃wp[NX<BR>
 * tB[h()\NXł<BR>
 *
 * @author Tosiki IGA
 */
public class JSourceCodeWizardField
	extends JSourceCodeWizardFieldAbstract
{
	protected JSourceCodeWizardChannel f_channel=null;

	/**
	 * channel(`l) setter<BR>
	 * 
	 *   @param JSourceCodeWizardChannel arg channel(`l)
	 */
	public void setChannel(JSourceCodeWizardChannel arg)
	{
		f_channel=arg;
	}

	/**
	 * channel(`l) getter<BR>
	 * 
	 *   @return JSourceCodeWizardChannel f_channel(`l)
	 */
	public JSourceCodeWizardChannel getChannel()
	{
		return f_channel;
	}

	public void printDescriptions(JSourceCodeWizard wizard,IndentWriter out)
	{
		boolean isFirst=true;
		if(getDescription()!=null)
		{
			if(isFirst)
			{
				out.println("");
				isFirst=false;
			}
			out.println(wizard.getString("src.common.description",new Object[]{getDescription()}));
		}
		if(getType()!=null)
		{
			if(isFirst)
			{
				out.println("");
				isFirst=false;
			}
			out.println("^:"+getType()+"<BR>");
		}
		if(getChild()!=null)
		{
			out.println("q̌^:"+getChild()+"<BR>");
		}
		if(getDelegate()!=null)
		{
			out.println("Ϗ:"+getDelegate()+"<BR>");
		}
		if(isPrimary())
		{
			out.println("vC}L[<BR>");
		}
		if(getLength()!=(-1))
		{
			out.println(":"+getLength()+"<BR>");
		}
		if(getDefault()!=null)
		{
			out.println("ftHgl:["+getDefault()+"]<BR>");
		}
		if(getNotNull())
		{
			out.println("NULL񂠂<BR>");
		}
	}

	public void processInitialize(JSourceCodeWizard wizard)
	{
		if(getDelegate()!=null)
		{
			JSourceCodeWizardField field=findDelegateField(wizard);
			if(field==null)return;
			setTitle(field.getTitle());
			setDescription(field.getDescription());
			setType(field.getType());
			setDefault(field.getDefault());
			setLength(field.getLength());
		}
	}

	/**
	 * write getter - setter <BR>
	 */
	public static final void writeGetSet(
		JSourceCodeWizard wizard,JSourceCodeWizardChannel dataChannel,ArrayList vecItem,IndentWriter out)
		throws IOException
	{
		out.addIndent(1);

		for(int index=0;index<vecItem.size();index++)
		{
			JSourceCodeWizardField item=(JSourceCodeWizardField)vecItem.get(index);
			out.beginComment();
			out.println(wizard.getString("src.field.setter.1",new Object[]{item.getName()+"("+item.getTitle()+")"}));
			item.printDescriptions(wizard,out);
			out.println("");
			out.println("  @param "+WizType.getWizAlterType(item.getType())+" arg "+item.getName()+"("+item.getTitle()+")");
			out.endComment();
			out.println("public void set"+JSourceCodeWizardProcessor.getUpper(item.getName())+"("+WizType.getWizAlterType(item.getType())+" arg)");
			out.println("{");
			if("String".equals(WizType.getWizAlterType(item.getType()))
			&& item.getLength()>0)
			{
				out.println(1,"arg=subString(arg,0,"+item.getLength()+");");
			}

			// ̑OɎ{ׂ
			if("java.math.BigDecimal".equals(item.getType()))
			{
				// ƂĎcĂ܂B
				//  ǂ̐lׂȂ̂ł傤B
				out.println(1,"arg.setScale("+item.getFractionLength()+",java.math.BigDecimal.ROUND_HALF_UP);");

				// ͊ԈႢ̖͗lBout.println(1,"arg.setScale("+item.getLength()+");");
			}

			if(item.getDelegate()==null)
			{
				out.println(1,item.getTitleFieldName()+WizType.getLoadPatternForType(item.getType(),"arg")+";");
			}
			else
			{
				JSourceCodeWizardField fieldDelegate=item.findDelegateField(wizard);
				if(fieldDelegate!=null)out.println(1,"f_"+fieldDelegate.getChannel().getName()+".set"+JSourceCodeWizardProcessor.getUpper(fieldDelegate.getName())+"(arg);");
			}

			out.println("}");
			out.println();

			out.beginComment();
			out.println(item.getName()+"("+item.getTitle()+") getter<BR>");
			item.printDescriptions(wizard,out);
			out.println("");
			out.println("  @return "+WizType.getWizAlterType(item.getType())+" "+item.getTitleFieldName()+"("+item.getTitle()+")");
			out.endComment();
			out.println("public "+WizType.getWizAlterType(item.getType())+" get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"()");
			out.println("{");

			if(item.getDelegate()==null)
			{
				String strGetter=WizType.getConvertPatternForType(item.getType(),WizType.getWizAlterType(item.getType()),item.getTitleFieldName());
				if(strGetter==null)
				{
					strGetter=item.getTitleFieldName();
				}
				out.println(1,"return "+strGetter+";");
			}
			else
			{
				JSourceCodeWizardField fieldDelegate=item.findDelegateField(wizard);
				if(fieldDelegate!=null)out.println(1,"return f_"+fieldDelegate.getChannel().getName()+".get"+JSourceCodeWizardProcessor.getUpper(fieldDelegate.getName())+"();");
			}

			out.println("}");
			out.println();

			if("boolean".equals(item.getType()))
			{
				out.beginComment();
				out.println(item.getName()+"("+item.getTitle()+") ̐^U<BR>");
				item.printDescriptions(wizard,out);
				out.println("");
				out.println("  @return boolean "+item.getTitleFieldName()+"("+item.getTitle()+")");
				out.endComment();
				out.println("public boolean is"+JSourceCodeWizardProcessor.getUpper(item.getName())+"()");
				out.println("{");
				out.println(1,"return get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"();");
				out.println("}");
				out.println();
			}

			// name
			out.println("public static String get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"Name()");
			out.println("{");
			out.println(1,"return \""+item.getName()+"\";");
			out.println("}");
			out.println();

			// title
			out.println("public static String get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"Title()");
			out.println("{");
			out.println(1,"return \""+item.getTitle()+"\";");
			out.println("}");
			out.println();

			if(item.getDescription()!=null
			&& item.getDescription().length()>0)
			{
				// description
				out.println("public static String get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"Description()");
				out.println("{");
				out.println(1,"return \""+item.getDescription()+"\";");
				out.println("}");
				out.println();
			}

			// type
			out.println("public String get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"Type()");
			out.println("{");
			out.println(1,"return \""+item.getType()+"\";");
			out.println("}");
			out.println();

			if(item.getDefault()!=null
			&& item.getDefault().length()>0)
			{
				// default
				out.println("public static "+item.getType()+" get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"Default()");
				out.println("{");
				out.println(1,"return "+item.getDefault()+";");
				out.println("}");
				out.println();
			}

			// length
			if(item.getLength()>0)
			{
				out.beginComment();
				out.println("length of "+item.getName()+"("+item.getTitle()+")<BR>");
				out.println("");
				out.println("  @return int length of "+item.getTitleFieldName()+"("+item.getTitle()+")");
				out.endComment();
				out.println("public static int get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"Length()");
				out.println("{");
				out.println(1,"return "+item.getLength()+";");
				out.println("}");
				out.println();
			}

			// fractionLength
			if(item.getFractionLength()>0)
			{
				out.println("public static int get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"FractionLength()");
				out.println("{");
				out.println(1,"return "+item.getFractionLength()+";");
				out.println("}");
				out.println();
			}
		}

		out.addIndent(-1);
	}

	public static final void writeCopy(
		JSourceCodeWizard wizard,JSourceCodeWizardChannel dataChannel,ArrayList vecItem,IndentWriter out)
		throws IOException
	{
		out.addIndent(1);
		for(int index=0;index<dataChannel.getFunction().getBind().size();index++)
		{
			String strCopyTarget=(String)dataChannel.getFunction().getBind().get(index);
			JSourceCodeWizard wizardTarget=findWizardFromXmlByClassName(wizard,dataChannel,strCopyTarget);

			out.beginComment();
			out.println("^ꂽIuWFNg瓯tB[h̓eIuWFNgɃRs[܂<BR>");
			out.println("");
			out.println("  @param "+JSourceCodeWizardProcessor.getMyClassName(wizardTarget,wizardTarget.getChannel())+" arg");
			out.endComment();
			out.println("public void parse("+JSourceCodeWizardProcessor.getMyClassName(wizardTarget,wizardTarget.getChannel())+" arg)");
			out.println("{");
			for(int indexSearchMyself=0;indexSearchMyself<vecItem.size();indexSearchMyself++)
			{
				JSourceCodeWizardField fieldMyself=(JSourceCodeWizardField)vecItem.get(indexSearchMyself);
				for(int indexSearchOther=0;indexSearchOther<wizardTarget.getField().size();indexSearchOther++)
				{
					JSourceCodeWizardField fieldOther=(JSourceCodeWizardField)wizardTarget.getField().get(indexSearchOther);
					if(fieldMyself.getName().equals(fieldOther.getName()))
					{
						String strGetter=WizType.getConvertPatternForType(WizType.getWizAlterType(fieldOther.getType()),WizType.getWizAlterType(fieldMyself.getType()),"arg.get"+JSourceCodeWizardProcessor.getUpper(fieldOther.getName())+"()");
						if(strGetter!=null)
						{
							out.println(1,"set"+JSourceCodeWizardProcessor.getUpper(fieldMyself.getName())+"("+strGetter+");");
						}
					}
				}
			}
			out.println("}");
			out.println(-1,"");
			out.beginComment();
			out.println("^ꂽIuWFNgɓtB[h̓eRs[܂<BR>");
			out.println("");
			out.println("  @param "+JSourceCodeWizardProcessor.getMyClassName(wizardTarget,wizardTarget.getChannel())+" arg");
			out.endComment();
			out.println("public void serialize("+JSourceCodeWizardProcessor.getMyClassName(wizardTarget,wizardTarget.getChannel())+" arg)");
			out.println("{");
			for(int indexSearchMyself=0;indexSearchMyself<vecItem.size();indexSearchMyself++)
			{
				JSourceCodeWizardField fieldMyself=(JSourceCodeWizardField)vecItem.get(indexSearchMyself);
				for(int indexSearchOther=0;indexSearchOther<wizardTarget.getField().size();indexSearchOther++)
				{
					JSourceCodeWizardField fieldOther=(JSourceCodeWizardField)wizardTarget.getField().get(indexSearchOther);
					if(fieldMyself.getName().equals(fieldOther.getName()))
					{
						String strGetter=WizType.getConvertPatternForType(WizType.getWizAlterType(fieldMyself.getType()),WizType.getWizAlterType(fieldOther.getType()),"get"+JSourceCodeWizardProcessor.getUpper(fieldOther.getName())+"()");
						if(strGetter!=null)
						{
							out.println(1,"arg.set"+JSourceCodeWizardProcessor.getUpper(fieldMyself.getName())+"("+strGetter+");");
						}
					}
				}
			}
			out.println("}");
			out.println(-1,"");
		}
		out.addIndent(-1);
	}

	public static JSourceCodeWizard findWizardFromXmlByClassName(JSourceCodeWizard wizard,JSourceCodeWizardChannel dataChannel,String strObject)
	{
		try{
			for(int index=0;index<dataChannel.getInclude().size();index++)
			{
				// 

				// 傤Ȃ̂ŁA.ŏIĂꍇɂ / C܂B
				if(wizard.getCurrentDirectory().endsWith("."))
				{
					wizard.setCurrentDirectory(wizard.getCurrentDirectory()+"/");
				}

				String strInclude=(String)dataChannel.getInclude().get(index);
				File fileInclude=new File(wizard.getCurrentDirectory()+strInclude);
				if(fileInclude.exists()==false)
				{
					System.out.println("    <"+wizard.getCurrentDirectory()+strInclude+">܂");
					//new Exception("TRACE").printStackTrace();
					continue;
				}
				JSourceCodeWizard accessReader=new JSourceCodeWizard();
				accessReader.setCurrentDirectory(wizard.getCurrentDirectory());
				accessReader.parseXml(fileInclude);
				if(accessReader.getChannel().getName().equals(strObject))
				{
					System.out.println("    <"+strInclude+">["+strObject+"]̋Lq.");
					return accessReader;
				}
				else
				{
					//System.out.println("`"+strInclude+"̒ɂ͂܂ł");
				}
			}
		}catch(IOException ex){
			System.out.println(ex.toString());
			ex.printStackTrace();
		}
		System.out.println("G[:tB[h["+strObject+"]̒`܂.");
		return null;
	}

	public JSourceCodeWizardField findDelegateField(JSourceCodeWizard wizard)
	{
		if(getDelegate()==null)return null;

		int iDot=getDelegate().indexOf('.');
		String strObject=getDelegate().substring(0,iDot);
		//System.out.println(strObject);
		String strField=getDelegate().substring(iDot+1);
		//System.out.println(strField);

		// 
		JSourceCodeWizard accessReader=findWizardFromXmlByClassName(wizard,getChannel(),strObject);
		if(accessReader==null)return null;

		// ̓tB[ȟ
		for(int indexField=0;indexField<accessReader.getField().size();indexField++)
		{
			JSourceCodeWizardField field=(JSourceCodeWizardField)accessReader.getField().get(indexField);
			if(field.getName().equals(strField))
			{
				return field;
			}
		}

		return null;
	}

	/**
	 * availableSql(SQLo͂\ǂ) getter<BR>
	 * 
	 *   @return boolean f_availableSql(SQLo͂\ǂ)
	 */
	public boolean getAvailableSql()
	{
		if(getDelegate()!=null
		&& getDelegate().length()>0)
		{
			// ϏڂSQLΏۊO
			return false;
		}

		if(WizType.isWizPremitiveType(getType()))
		{
			return true;
		}
		else
		{
			return super.getAvailableSql();
		}
	}

	/**
	 * availableXml(XMLo͂\ǂ) getter<BR>
	 * 
	 *   @return boolean f_availableXml(XMLo͂\ǂ)
	 */
	public boolean getAvailableXml()
	{
		if(WizType.isWizPremitiveTypeWithChild(this))
		{
			return true;
		}
		else
		{
			return super.getAvailableXml();
		}
	}

	/**
	 * availableTsv(TSVo͂\ǂ) getter<BR>
	 * 
	 *   @return boolean f_availableTsv(TSVo͂\ǂ)
	 */
	public boolean getAvailableTsv()
	{
		if(WizType.isWizPremitiveType(getType()))
		{
			return true;
		}
		else
		{
			return super.getAvailableTsv();
		}
	}

	public String getTitleFieldName()
	{
		return "f_"+getName();
	}

	/**
	 * ^ꂽ^ SQL DDL ǂ̌^ɓĂ͂߂̂
	 * l郋[`
	 */
	public String getSqlTypeInDdl()
	{
		String strType=WizType.getWizAlterType(getType());
		if("boolean".equals(strType))
		{
			setLength(1);
			return "CHAR(1)";
		}
		else if("char".equals(strType))
		{
			setLength(1);
			return "CHAR(1)";
		}
		else if("int".equals(strType))
		{
			return "INT";
		}
		else if("String".equals(strType))
		{
			return "CHAR("+getLength()+")";
		}
		else if("java.math.BigDecimal".equals(strType))
		{
			// Oracle 8.1.7  SQLServer 2000  DECIMAL^͑݁B
			// MS Accessɂ DECIMAL^͖
			// 1Ԗڂ̈: S (_)
			// 2Ԗڂ̈: 
			return "DECIMAL("+getLength()+","+getFractionLength()+")";
		}
		else
		{
			return "notDefined["+strType+"]";
		}

		//  TIMESTAMP
	}

	public void writeDefine(IndentWriter out)
		throws IOException
	{
		StringBuffer strbufWrk=new StringBuffer();
		strbufWrk.append("protected "+getType()+" "+getTitleFieldName());
		if(getDefault()!=null)
		{
			strbufWrk.append("="+getDefault());
		}
		strbufWrk.append(";");
		out.println(strbufWrk.toString());
	}

	/**
	 * ̃\bh͌邩Ƀt@N^Oł傤ǂA
	 * Ƃ dgݏ ȏ͍̂łB
	 */
	public void writeSqlSetParam(String strGuide,IndentWriter out)
		throws IOException
	{
		String strGetterPattern="get"+JSourceCodeWizardProcessor.getUpper(getName())+"()";
		if(strGuide!=null)
		{
			strGetterPattern=strGuide;
		}

		String strType=WizType.getWizAlterType(getType());
		if("boolean".equals(strType))
		{
			out.println("stmt.setString(iColumn++,("+WizType.getConvertPatternForType("char","String",WizType.getConvertPatternForType(strType,"char",strGetterPattern))+"));");
		}
		else if("char".equals(strType))
		{
			out.println("stmt.setString(iColumn++,("+WizType.getConvertPatternForType(strType,"String",strGetterPattern)+"));");
		}
		else if("int".equals(strType))
		{
			out.println("stmt.setInt(iColumn++,"+strGetterPattern+");");
		}
		else if("String".equals(strType))
		{
			if(getLength()>0)
			{
				out.println("stmt.setString(iColumn++,fitRight("+strGetterPattern+",get"+JSourceCodeWizardProcessor.getUpper(getName())+"Length(),' '"+"));");
			}
			else
			{
				out.println("stmt.setString(iColumn++,"+strGetterPattern+");");
			}
		}
		else if("java.math.BigDecimal".equals(strType))
		{
			out.println("stmt.setBigDecimal(iColumn++,"+strGetterPattern+");");
		}
		else
		{
			out.println("// T|[gODB^:"+strType);
		}
	}

	/**
	 * ̃\bh͌邩Ƀt@N^Oł傤ǂA
	 * Ƃ dgݏ ȏ͍̂łB
	 */
	public void writeSqlGetParam(IndentWriter out)
		throws IOException
	{
		String strType=WizType.getWizAlterType(getType());
		if("boolean".equals(strType))
		{
			out.println("set"+JSourceCodeWizardProcessor.getUpper(getName())+"("+WizType.getConvertPatternForType("char","boolean",WizType.getConvertPatternForType("String","char","resultSet.getString(iColumn++)"))+");");
		}
		else if("char".equals(strType))
		{
			out.println("set"+JSourceCodeWizardProcessor.getUpper(getName())+"("+WizType.getConvertPatternForType("String","char","resultSet.getString(iColumn++)")+");");
		}
		else if("int".equals(strType))
		{
			out.println("set"+JSourceCodeWizardProcessor.getUpper(getName())+"(resultSet.getInt(iColumn++));");
		}
		else if("String".equals(strType))
		{
			out.println("set"+JSourceCodeWizardProcessor.getUpper(getName())+"(trimRight(resultSet.getString(iColumn++)));");
		}
		else if("java.math.BigDecimal".equals(strType))
		{
			out.println("set"+JSourceCodeWizardProcessor.getUpper(getName())+"(resultSet.getBigDecimal(iColumn++));");
		}
	}

	public void writeXmlSetParam(IndentWriter out)
		throws IOException
	{
		String strConvertPattern=WizType.getConvertPatternForType("String",getType(),"getTextNodeValue(eleItemLook)");
		if(strConvertPattern!=null)
		{
			out.println("set"+JSourceCodeWizardProcessor.getUpper(getName())+"("+strConvertPattern+");");
		}
		else
		{
			if(getChild()==null)
			{
				out.println("f_"+getName()+".parse(eleItemLook);");
			}
			else
			{
				if(WizType.isWizPremitiveTypeWithChild(this))
				{
					strConvertPattern=WizType.getConvertPatternForType("String",getChild(),"getTextNodeValue(eleItemLook)");
					if(strConvertPattern!=null)
					{
						out.println(getChild()+" genItem="+strConvertPattern+";");
					}
				}
				else
				{
					out.println(getChild()+" genItem=new "+getChild()+"();");
					out.println("genItem.parse(eleItemLook);");
				}

				out.println("f_"+getName()+".add(genItem);");
			}
		}
	}

	public void writeTsvSetParam(String strSource,IndentWriter out)
		throws IOException
	{
		String strConvertPattern=WizType.getConvertPatternForType("String",getType(),strSource);
		if(strConvertPattern!=null)
		{
			out.println("set"+JSourceCodeWizardProcessor.getUpper(getName())+"("+strConvertPattern+");");
		}
	}

}

