/**
 * IgaLib -> wizard
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.wizard;

import jp.ne.nifty.iga.tosiki.string.*;
import java.io.*;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * JSourceCodeWizard ̃wp[NXB\[XR[hEBU[hs<BR>
 * \[XR[hEBU[hsă\[XR[h𐶐镔ł<BR>
 *
 * @author Tosiki IGA
 */
public class JSourceCodeWizardProcessor
{
	/**
	 * 
	 *
	 * @param String strDirectory ݐfBNg
	 */
	public static final void write(JSourceCodeWizard wizard,JSourceCodeWizardChannel dataChannel,ArrayList vecItem,String strDirectory)
		throws IOException
	{
		IndentWriter indentWriter=new IndentWriter(new OutputStreamWriter(new FileOutputStream(strDirectory+getMyClassName(wizard,dataChannel)+".java")));

		JSourceCodeWizardProcessor.writeHead(wizard,dataChannel,vecItem,indentWriter);
		JSourceCodeWizardField.writeGetSet(wizard,dataChannel,vecItem,indentWriter);
		JSourceCodeWizardField.writeCopy(wizard,dataChannel,vecItem,indentWriter);
		JSourceCodeWizardProcessor.writeBasicFunction(wizard,dataChannel,vecItem,indentWriter);

		JSourceCodeWizardProcessorFunction.writeFunction(wizard,dataChannel,vecItem,indentWriter);

		if(dataChannel.getFunction().getUseSql())
		{
			JSourceCodeWizardProcessorSql.write(wizard,dataChannel,vecItem,indentWriter);
		}

		JSourceCodeWizardProcessor.writeCommonFunction(wizard,dataChannel,vecItem,indentWriter);

		if(dataChannel.getFunction().getUseXml())
		{
			JSourceCodeWizardProcessorXml.writeXmlFunction(wizard,dataChannel,vecItem,indentWriter);
		}

		if(dataChannel.getFunction().getUseCsv())
		{
			new JSourceCodeWizardProcessorCsv().writeFunction(wizard,dataChannel,vecItem,indentWriter);
		}

		if(dataChannel.getFunction().getUseTsv())
		{
			new JSourceCodeWizardProcessorTsv().writeFunction(wizard,dataChannel,vecItem,indentWriter);
		}

		JSourceCodeWizardProcessor.writeTail(wizard,dataChannel,vecItem,indentWriter);

		indentWriter.flush();
		indentWriter.close();
	}

	/**
	 * wb_`Eϐ錾Ȃ
	 */
	public static final void writeHead(
		JSourceCodeWizard wizard,JSourceCodeWizardChannel dataChannel,ArrayList vecItem,IndentWriter out)
		throws IOException
	{
		out.beginComment();
		out.println(wizard.getString("src.head.comment.define",new Object[]{dataChannel.getName()+" ("+dataChannel.getTitle()+")"}));
		if(dataChannel.getDescription()!=null)out.println(wizard.getString("src.common.description",new Object[]{dataChannel.getDescription()}));
		out.println(dataChannel.getCopyright()+"<BR>");
		out.println("");
		out.println(wizard.getString("src.head.comment.warn.1"));
		out.println(wizard.getString("src.head.comment.warn.2"));
		out.println(wizard.getString("src.head.comment.warn.3"));
		out.endComment();
		out.println("");

		if(dataChannel.getPackage()!=null
		&& dataChannel.getPackage().length()>0)
		{
			out.println("package "+dataChannel.getPackage()+";");
			out.println("");
		}

		for(int index=0;index<dataChannel.getImport().size();index++)
		{
			String strImport=(String)dataChannel.getImport().get(index);
			out.println("import "+strImport+";");
		}
		out.println("import java.io.*;");
		out.println("import java.util.*;");
		out.println("");

		out.beginComment();
		out.println(wizard.getString("src.head.comment.classdefine",new Object[]{dataChannel.getName()+" ("+dataChannel.getTitle()+")"}));
		if(dataChannel.getDescription()!=null)out.println(wizard.getString("src.common.description",new Object[]{dataChannel.getDescription()}));
		out.println("");
		out.println(wizard.getString("src.head.comment.warn.1"));
		out.println(wizard.getString("src.head.comment.warn.2"));
		out.println(wizard.getString("src.head.comment.warn.3"));
		out.println("");
		// useSql̏ꍇ Ƀe[u\}
		if(dataChannel.getFunction().getUseSql())
		{
			JSourceCodeWizardProcessorSql.writeHeadder(wizard,dataChannel,vecItem,out);
		}
		out.println("");
		out.println("  @author "+dataChannel.getAuthor());
		{
			SimpleDateFormat dateFormat=new SimpleDateFormat("yyyy.MM.dd");
			out.println("  @version "+dateFormat.format(new Date()));
		}
		out.endComment();
		out.println("public class "+getMyClassName(wizard,dataChannel));
		if(dataChannel.getFunction().isUseServlet())
		{
			out.println(1,"extends javax.servlet.http.HttpServlet");
		}
		else if(dataChannel.getFunction().isUseSwing())
		{
			out.println(1,"extends javax.swing.JPanel");
		}
		out.println(1,"implements java.lang.Comparable");
		out.println("{");

		for(int index=0;index<vecItem.size();index++)
		{
			JSourceCodeWizardField item=(JSourceCodeWizardField)vecItem.get(index);
			if(item.getDelegate()!=null
			&& item.getDelegate().length()>0)
			{
				continue;
			}

			out.addIndent(1);
			out.beginComment();
			out.println(item.getName()+"("+item.getTitle()+")<BR>");
			item.printDescriptions(wizard,out);
			out.endComment();

			item.writeDefine(out);

			out.addIndent(-1);

			out.println("");
		}

		{
			out.addIndent(1);
			out.beginComment();
			out.println(wizard.getString("src.wiz.shortname.getter.1"));
			out.println(wizard.getString("src.wiz.shortname.getter.2"));
			out.println(wizard.getString("src.wiz.shortname.getter.3"));
			out.endComment();
			out.println("public static String getWizardShortName()");
			out.println("{");
			out.println(1,"return \""+dataChannel.getName()+"\";");
			out.println("}");
			out.addIndent(-1);

			out.println("");
		}
	}

	public static final void writeTail(
		JSourceCodeWizard wizard,JSourceCodeWizardChannel dataChannel,ArrayList vecItem,IndentWriter out)
		throws IOException
	{
		out.println("}");
	}

	public static final void writeBasicFunction(
		JSourceCodeWizard wizard,JSourceCodeWizardChannel dataChannel,ArrayList vecItem,IndentWriter out)
		throws IOException
	{
		out.addIndent(1);

		out.beginComment();
		out.println(dataChannel.getName()+"("+dataChannel.getTitle()+") ̕\p̎擾<BR>");
		out.println("");
		out.println("  @return \p");
		out.endComment();
		out.println("public String getDisplayString()");
		out.println("{");

		out.addIndent(1);

		out.println("StringBuffer strbufDisplay=new StringBuffer();");
		out.println("strbufDisplay.append(\""+dataChannel.getName()+"\");");
		out.println("strbufDisplay.append(\"[\");");

		boolean isFirstColumn=true;
		for(int index=0;index<vecItem.size();index++)
		{
			JSourceCodeWizardField item=(JSourceCodeWizardField)vecItem.get(index);
			if(item.isAvailableSql()==false)continue;
			if(isFirstColumn)
			{
				isFirstColumn=false;
			}
			else
			{
				out.println("strbufDisplay.append(\",\");");
			}
			out.println("strbufDisplay.append(\""+item.getName()+"=\"+get"+getUpper(item.getName())+"());");
		}

		out.println("strbufDisplay.append(\"]\");");

		out.println("return strbufDisplay.toString();");

		out.addIndent(-1);
		out.println("}");
		out.println("");
		out.beginComment();
		out.println(dataChannel.getName()+"("+dataChannel.getTitle()+") IuWFNg̔r<BR>");
		out.println("");
		out.println("  @param Object obj rIuWFNg");
		out.println("  @return v邩ǂ");
		out.endComment();
		out.println("public boolean equals(Object obj)");
		out.println("{");

		out.addIndent(1);

		out.println("if(this==obj)return true;");
		out.println("if(null==obj)return false;");
		out.println(getMyClassName(wizard,dataChannel)+" arg=("+getMyClassName(wizard,dataChannel)+")obj;");

		for(int index=0;index<vecItem.size();index++)
		{
			JSourceCodeWizardField item=(JSourceCodeWizardField)vecItem.get(index);
			String strGetterPattern="get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"()";
			boolean isPremetive=WizType.isJavaPremitiveType(WizType.getWizAlterType(item.getType()));
			if(isPremetive==false)
			{
				out.println("if("+strGetterPattern+"==null)");
				out.println("{");
				out.addIndent(1);
			}

			out.println("if("+strGetterPattern+"!=arg."+strGetterPattern+")");
			out.println("{");
			if(dataChannel.getFunction().isUseDebug())out.println(1,"System.out.println(\"field ["+item.getName()+"] is not equal.\");");
			out.println(1,"return false;");
			out.println("}");

			if(isPremetive==false)
			{
				out.println(-1,"}");
				out.println(-1,"else");
				out.println(-1,"{");

				if("java.math.BigDecimal".equals(item.getType()))
				{
					out.println("if("+strGetterPattern+".compareTo(arg."+strGetterPattern+")!=0)");
				}
				else
				{
					out.println("if("+strGetterPattern+".equals(arg."+strGetterPattern+")==false)");
				}
				out.println("{");
				if(dataChannel.getFunction().isUseDebug())out.println(1,"System.out.println(\"field ["+item.getName()+"] is not equal.\");");
				out.println(1,"return false;");
				out.println("}");
			}

			if(isPremetive==false)
			{
				out.addIndent(-1);
				out.println("}");
			}
			out.println("");
		}
		out.println("return true;");
		out.addIndent(-1);
		out.println("}");
		out.println("");

		out.beginComment();
		out.println(dataChannel.getName()+"("+dataChannel.getTitle()+") IuWFNgr<BR>");
		out.println("");
		out.println("  @return int r");
		out.endComment();
		out.println("public int compareTo("+getMyClassName(wizard,dataChannel)+" arg)");
		out.println("{");
		out.addIndent(1);
		out.println("int iCompare=0;");
		for(int index=0;index<vecItem.size();index++)
		{
			JSourceCodeWizardField item=(JSourceCodeWizardField)vecItem.get(index);
			String strGetterPattern="get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"()";

			if("String".equals(item.getType())
			|| "java.math.BigDecimal".equals(item.getType()))
			{
				out.println("iCompare="+strGetterPattern+".compareTo(arg."+strGetterPattern+");");
				out.println("if(iCompare!=0)return iCompare;");
			}
			else if("int".equals(item.getType())
			||      "char".equals(item.getType()))
			{
				out.println("iCompare="+strGetterPattern+"-arg."+strGetterPattern+";");
				out.println("if(iCompare!=0)return iCompare;");
			}
		}
		out.println("return 0;");
		out.addIndent(-1);
		out.println("}");
		out.println("");

		out.beginComment();
		out.println(dataChannel.getName()+"("+dataChannel.getTitle()+") IuWFNgr<BR>");
		out.println("");
		out.println("  @return int r");
		out.endComment();
		out.println("public int compareTo(Object arg)");
		out.println("{");
		out.addIndent(1);
		out.println("return compareTo(("+getMyClassName(wizard,dataChannel)+")arg);");
		out.addIndent(-1);
		out.println("}");
		out.println("");

		out.beginComment();
		out.println(dataChannel.getName()+"("+dataChannel.getTitle()+") IuWFNg̃\[gr<BR>");
		out.println("");
		out.println("  @return java.util.Comparator rc[");
		out.endComment();
		out.println("public static java.util.Comparator getComparator()");
		out.println("{");

		out.addIndent(1);

		out.println("return new java.util.Comparator()");
		out.println("{");
		out.addIndent(1);
		out.println("public int compare(Object obj1, Object obj2)");
		out.println("{");
		out.addIndent(1);
		out.println(getMyClassName(wizard,dataChannel)+" arg1=("+getMyClassName(wizard,dataChannel)+")obj1;");
		out.println(getMyClassName(wizard,dataChannel)+" arg2=("+getMyClassName(wizard,dataChannel)+")obj2;");
		out.println("return arg1.compareTo(arg2);");
		out.addIndent(-1);
		out.println("}");
		out.addIndent(-1);
		out.println("};");
		out.addIndent(-1);
		out.println("}");
		out.println("");

		out.beginComment();
		out.println(dataChannel.getName()+"("+dataChannel.getTitle()+") ̕tB[hEl<BR>");
		out.endComment();
		out.println("public void trimRight()");
		out.println("{");

		out.addIndent(1);

		for(int index=0;index<vecItem.size();index++)
		{
			JSourceCodeWizardField item=(JSourceCodeWizardField)vecItem.get(index);
			if("String".equals(item.getType()))
			{
				String strGetterPattern="get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"()";
				String strSetterPattern="set"+JSourceCodeWizardProcessor.getUpper(item.getName());
				out.println(strSetterPattern+"(trimRight("+strGetterPattern+"));");
			}
		}

		out.addIndent(-1);
		out.println("}");

		out.println("");
		out.beginComment();
		out.println(dataChannel.getName()+"("+dataChannel.getTitle()+") ̓ǂݍ<BR>");
		out.endComment();
		out.println("public void parse("+getMyClassName(wizard,dataChannel)+" arg)");
		out.println("{");

		out.addIndent(1);

		for(int index=0;index<vecItem.size();index++)
		{
			JSourceCodeWizardField item=(JSourceCodeWizardField)vecItem.get(index);
			String strGetterPattern="get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"()";
			String strSetterPattern="set"+JSourceCodeWizardProcessor.getUpper(item.getName());
			out.println(strSetterPattern+"(arg."+strGetterPattern+");");
		}

		out.addIndent(-1);
		out.println("}");

		out.println("");
		out.beginComment();
		out.println(dataChannel.getName()+"("+dataChannel.getTitle()+") ̏o<BR>");
		out.endComment();
		out.println("public void serialize("+getMyClassName(wizard,dataChannel)+" arg)");
		out.println("{");

		out.addIndent(1);

		for(int index=0;index<vecItem.size();index++)
		{
			JSourceCodeWizardField item=(JSourceCodeWizardField)vecItem.get(index);
			String strGetterPattern="get"+JSourceCodeWizardProcessor.getUpper(item.getName())+"()";
			String strSetterPattern="set"+JSourceCodeWizardProcessor.getUpper(item.getName());
			out.println("arg."+strSetterPattern+"("+strGetterPattern+");");
		}

		out.addIndent(-1);
		out.println("}");

		out.addIndent(-1);
		out.println("");
	}

	public static final String getMyClassName(JSourceCodeWizard wizard,JSourceCodeWizardChannel dataChannel)
	{
		StringBuffer strbufFilename=new StringBuffer();
		if(dataChannel.getPrefix()!=null)
		{
			strbufFilename.append(dataChannel.getPrefix());
		}
		strbufFilename.append(getUpper(dataChannel.getName()));
		if(dataChannel.getSuffix()!=null)
		{
			strbufFilename.append(dataChannel.getSuffix());
		}
		return strbufFilename.toString();
	}

	public static final String getUpper(String arg)
	{
		if(arg.length()<=0)return arg;
		return Character.toUpperCase(arg.charAt(0))+arg.substring(1,arg.length());
	}

	/**
	 * ʊ֐΂Ƒ}܂B
	 * ̏ꏊg GȂłB
	 */
	public static final void writeCommonFunction(
		JSourceCodeWizard wizard,JSourceCodeWizardChannel dataChannel,ArrayList vecItem,IndentWriter out)
		throws IOException
	{
		JSourceCodeWizardProcessorMojiUtil.writeMojiUtil(out);
	}
}

