/**
 * IgaLib -> wizard
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.wizard;

import jp.ne.nifty.iga.tosiki.string.IndentWriter;
import junit.framework.TestCase;
import java.io.*;

/**
 * \[XR[hEBU[heXgNXłB
 * JUnit𗘗păeXg{邽߂ɑ݂NXłB<BR>
 * ̃NXg̗prɗp邱Ƃ͖ł傤B
 *
 * @author Tosiki IGA
 */
public class JSourceCodeWizardTest
	extends TestCase
{
	public JSourceCodeWizardTest(String name)
	{
		super(name);
	}

	public static final void main(String[] args)
	{
		junit.textui.TestRunner.run(JSourceCodeWizardTest.class);
	}

	public void testJSourceCodeWizard()
		throws IOException
	{
		JSourceCodeWizard.writeDefFile("./sample/JSourceCodeWizardSample-auto.xml");
		JSourceCodeWizard.main(new String[0]);
	}

	public void testGetUpper()
		throws IOException
	{
		assertEquals("Test",JSourceCodeWizardProcessor.getUpper("test"));
	}

	public void testIndentWriter()
		throws IOException
	{
		IndentWriter.convert(new File("./jp/ne/nifty/iga/tosiki/string/MojiUtil.java"),new File("./sample/MojiUtil.java.encode.txt"));
		IndentWriter.convert(new File("./sample/encode.input.txt"),new File("./sample/encode.output.txt"));
	}
}


