/**
 * IgaLib -> wizard
 * Copyright (C) 2001  Tosiki IGA , IgaLib project member
 *   (http://homepage2.nifty.com/igat/igapyon/index.html)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package jp.ne.nifty.iga.tosiki.wizard;

import jp.ne.nifty.iga.tosiki.wizard.wiz.*;
import java.io.*;
import java.util.*;

/**
 * EBU[h^Ɋւ郉Cu<BR>
 * Ȃׂ "String" , "javax.swing.JCheckBox" Ȃǂ̋LqɏW񂵂łB
 */
public class WizType
{
	/**
	 * ͂ꂽϐp^[ ^ɓK`ɕϊ邽߂
	 * p^[Qbg܂B<BR>
	 * ̃\bh͑ςɏdvłBƂ̂^ϊĂ̂łB
	 * getType()ȂǂŖ߂l𗘗p܂B
	 * ꍇɂẮATypegetWizAlterType()ŏC邱Ƃ܂B
	 *
	 *   @param String strSourceType ͑̌^
	 *   @param String strTargetType o͑̌^
	 *   @param String strSource     ͕
	 *   @return String              ϊ㕶Bϊs\ꍇnullB
	 */
	public static final String getConvertPatternForType(String strSourceType,String strTargetType,String strSource)
	{
		if("boolean".equals(strSourceType))
		{
			if("boolean".equals(strTargetType))
			{
				return "("+strSource+")";
			}
			else if("char".equals(strTargetType))
			{
				return "("+strSource+"?'t':'f')";
			}
			else if("int".equals(strTargetType))
			{
				return "(1=="+strSource+")";
			}
			else if("String".equals(strTargetType))
			{
				return "("+strSource+"?\"t\":\"f\")";
			}
		}
		if("char".equals(strSourceType))
		{
			if("boolean".equals(strTargetType))
			{
				return "("+strSource+"=='t'?true:false)";
			}
			else if("char".equals(strTargetType))
			{
				return "("+strSource+")";
			}
			else if("int".equals(strTargetType))
			{
				return "((int)"+strSource+")";
			}
			else if("String".equals(strTargetType))
			{
				return "(\"\"+"+strSource+")";
			}
		}
		else if("int".equals(strSourceType))
		{
			if("boolean".equals(strTargetType))
			{
				return "(\"1\".equals("+strSource+")?true:false)";
			}
			else if("char".equals(strTargetType))
			{
				return "((int)"+strSource+")";
			}
			else if("int".equals(strTargetType))
			{
				return "("+strSource+")";
			}
			else if("String".equals(strTargetType))
			{
				return "(\"\"+"+strSource+")";
			}
		}
		else if("String".equals(strSourceType))
		{
			if("boolean".equals(strTargetType))
			{
				return "(\"true\".equals("+strSource+")?true:false)";
			}
			else if("char".equals(strTargetType))
			{
				return "("+strSource+".charAt(0))";
			}
			else if("int".equals(strTargetType))
			{
				return "(toInteger("+strSource+"))";
			}
			else if("String".equals(strTargetType))
			{
				return "("+strSource+")";
			}
			else if("java.math.BigDecimal".equals(strTargetType))
			{
				return "(new java.math.BigDecimal("+strSource+"))";
			}
		}
		else if("java.math.BigDecimal".equals(strSourceType))
		{
			if("String".equals(strTargetType))
			{
				return "(("+strSource+").toString())";
			}
			else if("java.math.BigDecimal".equals(strTargetType))
			{
				return "("+strSource+")";
			}
		}
		else if("javax.swing.JCheckBox".equals(strSourceType))
		{
			if("boolean".equals(strTargetType))
			{
				return "("+strSource+".isSelected())";
			}
		}
		else if("javax.swing.JTextField".equals(strSourceType))
		{
			if("String".equals(strTargetType))
			{
				return "("+strSource+".getText())";
			}
		}

		//System.out.println("\"getConvertPatternForType("+strSourceType+","+strTargetType+","+strSource+") is NOT supported.\"");
		return null;
	}

	/**
	 * ̕p^[擾܂B<BR>
	 * ȂA{Iɂ OɌ^Ă̂Ƃ̑O̎łB
	 */
	public static final String getLoadPatternForType(String strTargetType,String strSource)
	{
		if("javax.swing.JCheckBox".equals(strTargetType))
		{
			return ".setSelected("+strSource+")";
		}
		else if("javax.swing.JTextField".equals(strTargetType))
		{
			return ".setText("+strSource+")";
		}
		else
		{
			return "="+strSource;
		}
	}

	/**
	 * EBU[ḧ{^ւƌ^ǂݑւ܂B
	 */
	public static final String getWizAlterType(String strType)
	{
		if("javax.swing.JCheckBox".equals(strType))
		{
			return "boolean";
		}
		else if("javax.swing.JTextField".equals(strType))
		{
			return "String";
		}
		return strType;
	}

	/**
	 * ^ꂽ^Javaɂ
	 * v~eBu^ǂ`FbN܂B
	 */
	public static final boolean isJavaPremitiveType(String strType)
	{
		if("boolean".equals(strType)
		|| "char".equals(strType)
		|| "int".equals(strType))
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	/**
	 * ^ꂽ^\[XR[hEBU[hɂ
	 * v~eBu^ǂ`FbN܂B
	 */
	public static final boolean isWizPremitiveType(String strType)
	{
		if("boolean".equals(strType)
		|| "char".equals(strType)
		|| "int".equals(strType)
		|| "String".equals(strType)
		|| "java.math.BigDecimal".equals(strType)
		|| "javax.swing.JCheckBox".equals(strType)
		|| "javax.swing.JTextField".equals(strType))
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	/**
	 * ^ꂽtB[h̎܂͎q̌^
	 * \[XR[hEBU[hɂv~eBu^ǂ`FbN܂B
	 */
	public static final boolean isWizPremitiveTypeWithChild(JSourceCodeWizardField field)
	{
		if("boolean".equals(field.getType())
		|| "char".equals(field.getType())
		|| "int".equals(field.getType())
		|| "String".equals(field.getType())
		|| "java.math.BigDecimal".equals(field.getType())
		|| "javax.swing.JCheckBox".equals(field.getType())
		|| "javax.swing.JTextField".equals(field.getType()))
		{
			return true;
		}
		else if("boolean".equals(field.getChild())
		|| "char".equals(field.getChild())
		|| "int".equals(field.getChild())
		|| "String".equals(field.getChild())
		|| "java.math.BigDecimal".equals(field.getChild())
		|| "javax.swing.JCheckBox".equals(field.getChild())
		|| "javax.swing.JTextField".equals(field.getChild()))
		{
			// qXg̓VACY\
			return true;
		}
		else
		{
			return false;
		}
	}
}

